#ifndef __AUDIO_H__
#define __AUDIO_H__


#include <zephyr.h>
#include <zephyr/types.h>
#include <stddef.h>
#include <string.h>
#include <errno.h>
#include <sys/printk.h>
#include <sys/byteorder.h>

#include "pdm.h"
#include "eram.h"
#include "bleas.h"
#include "blef.h"


#define AUDIO_BUFFER_SIZE		(PDM_DMA_BUFF_SIZE)
#define AUDIO_MAX_CAPTURE_SIZE	((ERAM_MEMORY_SIZE)/2)

#define AUDIO_STATUS_IDLE		0
#define AUDIO_STATUS_CAPTURE	1
#define AUDIO_STATUS_DATA_READY	2

#define AUDIO_STREAMING_STATUS		0x4A
#define AUDIO_STREAMING_INIT		0
#define AUDIO_STREAMING_REINIT		1
#define AUDIO_STREAMING_COMPLETE	2

typedef enum
{
	AUDIO_STATE_IDLE = 0,
	AUDIO_STATE_INIT,
	AUDIO_STATE_WAIT4CAPTURE_END,
	AUDIO_STATE_CAPTURE_COMPLETED,
	AUDIO_STATE_CNT,
} Audio_States_t;

typedef struct
{
	uint8_t status;
	uint8_t state;
	uint16_t buff0[AUDIO_BUFFER_SIZE];
	uint16_t buff1[AUDIO_BUFFER_SIZE];
	uint32_t widx;
	uint32_t ridx;
	uint32_t cap_size;
	uint8_t stop;
	uint32_t idle_cnt;
} AUDIO_INFO;

void initAUDIO(void);
void chkAUDIO(void);
void restartAUDIO(void);
void stopAUDIO(void);
extern AUDIO_INFO g_AUDIO_INFO;

#endif 
