#ifndef __BLEAS_H__
#define __BLEAS_H__

#include <stdio.h>
#include <stddef.h>
#include <string.h>
#include <errno.h>

#include <zephyr.h>
#include <drivers/sensor.h>
#include <sys/printk.h>
#include <sys/byteorder.h>

#include <bluetooth/bluetooth.h>
#include <bluetooth/hci.h>
#include <bluetooth/conn.h>
#include <bluetooth/uuid.h>
#include <bluetooth/gatt.h>

#ifdef __cplusplus
extern "C" {
#endif


#define BLE_NOTIFICATION_DISABLED						0
#define BLE_NOTIFICATION_ENABLED						1
#define BLE_NOT_CONNECTED								0
#define BLE_CONNECTED									1

#define BLE_PAYLOAD_SIZE								244          // 
#define BLE_BUFFER_SIZE									512
#define BLE_BUFFER_MASK									((BLE_BUFFER_SIZE)-1)


typedef struct ble_info_t
{
	uint8_t cflag;					// connection state flag
	
	uint8_t notification_state;
	uint8_t sensor_notification_state;
	uint8_t state;
	
	uint8_t rx_buff[BLE_BUFFER_SIZE];
	uint16_t rx_buff_widx;
	uint16_t rx_buff_ridx;

	
	uint8_t eptype;
	uint8_t epresult;
	uint8_t eutype;			// update type: add or erase
	
	uint8_t udp_state;
	uint8_t udp_stream;
	uint32_t udp_timestamp;
	uint16_t udp_pkt_cnt;
	uint32_t udp_data_idx;
} BLE_INFO;



void initASBLE(void);
void txDataASBLE(struct bt_conn *active_conn, uint8_t * data, uint16_t size);
void txSensorDataASBLE(struct bt_conn *active_conn, uint8_t * data, uint16_t size);
int notify(struct bt_conn *active_connm, const struct bt_uuid *uuid, const struct bt_gatt_attr *attr, const void *data, uint16_t len) ;

extern volatile BLE_INFO g_BLE_INFO;
extern struct k_poll_signal signal_audio_action;
extern struct k_poll_signal signal_sensor_action;
extern struct k_poll_signal signal_udp_action;
#ifdef __cplusplus
}
#endif


#endif
