#ifndef __BLEF_H__
#define __BLEF_H__

/******************************************************************************
* Includes
*******************************************************************************/
#include <zephyr.h>
#include "config.h"
#include "bleas.h"

#include <bluetooth/bluetooth.h>
#include <bluetooth/hci.h>
#include <bluetooth/conn.h>
#include <bluetooth/uuid.h>
#include <bluetooth/gatt.h>
#include <bluetooth/services/bas.h>
#include <zephyr/types.h>
#include <stddef.h>
#include <string.h>
#include <errno.h>
#include <sys/printk.h>
#include <sys/byteorder.h>



/******************************************************************************
* Module configuration
*******************************************************************************/

/******************************************************************************
* Preprocessor Constants
*******************************************************************************/


#define BLE_NOT_INITIALIZED								0x00
#define BLE_INITIALIZED									0x01

#define BLE_DATA_NOT_READY								0x00
#define BLE_DATA_READY									0x01



#define BLE_DEV_STATE_IDLE								0x00
#define BLE_DEV_STATE_FAILED2INIT_BLE_STACK				0x01
#define BLE_DEV_STATE_FAILED2SET_BLE_NAME				0x02
#define BLE_DEV_STATE_ADVERTISING						0x03
#define BLE_DEV_STATE_FAILED2START_ADVERTISING			0x04
#define BLE_DEV_STATE_CONNECTED							0x05
#define BLE_DEV_STATE_FAILED2CONNECT					0x06
#define BLE_DEV_STATE_FAILED2PAIR						0x07
#define BLE_DEV_STATE_PAIRING_COMPLETED					0x08
#define BLE_DEV_STATE_PAIRING_FAILED					0x09


#define BLE_CMD_ERROR_WRONG_CHUNK_OR_COUNT				0x10

#define BLE_PKT_ERROR									0x00
#define BLE_PKT_OK										0x01
#define BLE_NETWORK_STATUS_NOT_SENT						0x00
#define BLE_NETWORK_STATUS_SENT							0x01

/******************************************************************************
* Macros
*******************************************************************************/

/******************************************************************************
* Typedefs
*******************************************************************************/

/******************************************************************************
* Global Variables
*******************************************************************************/

/******************************************************************************
* Function Prototypes
*******************************************************************************/

uint8_t initBLE(void);
uint8_t txPktBLE(uint8_t * payload, uint16_t size);
uint8_t txSensorPktBLE(uint8_t * payload, uint16_t size);
uint16_t getBytesAvailableBLE(void);

#endif 

    