/* Define to prevent recursive inclusion *********************************** */
#ifndef __CMD_H
#define __CMD_H

/* Includes **************************************************************** */
#include "stdint.h"
#include "blef.h"
#include "bleas.h"
#include "cmdapi.h"
#include "delay.h"


/* Module configuration **************************************************** */
#define txPktCMD(data,size)										txPktBLE(data, size)
#define CMD_RX_BUFFER_SIZE                                      BLE_BUFFER_SIZE
#define g_cmd_rx_buffer                                         g_BLE_INFO.rx_buff 
#define g_cmd_rx_ridx                                           g_BLE_INFO.rx_buff_ridx
#define g_cmd_rx_widx                                           g_BLE_INFO.rx_buff_widx
    
#define CMD_PACKAGE_FRAGMENTATION_ENABLE                        0
#define CMD_PACKAGE_SYNCE_BYTE0_ENABLE                          1 
#define CMD_PACKAGE_SYNCE_BYTE1_ENABLE                          0
#define CMD_PACKAGE_SYNCE_BYTE0_VALUE                           0xA5
#define CMD_PACKAGE_SYNCE_BYTE1_VALUE                           0x5A
#define CMD_PACKAGE_MAX_FRAGMENTS                               1
#define CMD_PACKAGE_SIZE                                        BLE_PAYLOAD_SIZE

/* Exported constants ****************************************************** */
#define CMD_SYSTEM_INFO_PERIOD              5000

/* Exported macros ********************************************************* */

/* Exported types ********************************************************** */

typedef enum 
{
	CMD_STATE_IDLE = 0x00,
	CMD_STATE_ACTIVE,
	CMD_STATE_CRC_ERROR,
} CMD_STATE;


typedef struct
{
	uint8_t state;

	uint8_t cmd;
	uint8_t size;
    uint8_t chunk;
	uint8_t payload[CMD_PACKAGE_MAX_FRAGMENTS][CMD_PACKAGE_SIZE];
    uint8_t crc;

    uint32_t system_info_timer;
} CMD_INFO;

/* Exported variables ****************************************************** */
extern volatile  CMD_INFO g_CMD_INFO;

/* Exported functions ****************************************************** */
void initCMD(void);
void chkCMD(void);
uint8_t getNextCMD(void);
void txCMD(uint8_t cmd,uint8_t chunk,uint8_t * payload,uint8_t size);


#endif
/* ***************************** END OF FILE ******************************* */
