/* Define to prevent recursive inclusion *********************************** */
#ifndef __CMD_API_H__
#define __CMD_API_H__

/* Includes **************************************************************** */
#include "mcu.h"
#include "cmd.h"
#include "config.h"
#include "bleas.h"
#include "audio.h"
#include "eram.h"


/* Exported constants ****************************************************** */
#define CMDAPI_SIZE                         5

#define CMD_FW_CAPTURE_STATUS_REQ           0x50
#define CMD_FW_CAPTURE_STATUS_REP           0x51
#define CMD_FW_SET_CAPTURE_STATE            0x52
#define CMD_FW_STREAM_INIT_REQ              0x53
#define CMD_FW_STREAM_INIT_REP              0x54
#define CMD_FW_STREAM_DATA_REQ              0x55
#define CMD_FW_STREAM_DATA_REP              0x56
#define CMD_FW_UDP_REQ						0x63
#define CMD_FW_UDP_REP						0x64

/* Exported macros ********************************************************* */

/* Exported types ********************************************************** */
typedef struct
{
    uint8_t cmd;
    void (*exeCmd)(void);
} CMDAPI_INFO;

/* Exported variables ****************************************************** */
extern volatile CMDAPI_INFO g_CMDAPI_INFO[CMDAPI_SIZE];

/* Exported functions ****************************************************** */

void getCaptureStatusCMDAPI(void);
void setCaptureStateCMDAPI(void);
void streamInitReqCMDAPI(void);
void getDataCMDAPI(void);
void udpInitReqCMDAPI(void);
void txUdpDataCMDAPI(void);


#endif
