#ifndef __PDM_H__
#define __PDM_H__

#include <zephyr.h>
#include <zephyr/types.h>
#include <stddef.h>
#include <string.h>
#include <errno.h>
#include <sys/printk.h>
#include <sys/byteorder.h>

// #define PDM_CLK_PIN						12
// #define PDM_DIN_PIN						11
#define PDM_CLK_PIN                     30
#define PDM_DIN_PIN                     31


#define PDM_DMA_BUFF_SIZE				512



typedef struct
{
	int16_t buff1[PDM_DMA_BUFF_SIZE];
	int16_t buff2[PDM_DMA_BUFF_SIZE];
	//int16_t abuff[PDM_DMA_BUFF_SIZE];
	//int16_t sram[48000];
	void (*event_handler)(uint8_t);
    int16_t *                    buff_address[2];   ///< Sample buffers.
    uint16_t                     buff_length[2];    ///< Length of the sample buffers.
    uint8_t                      status;        	///< Driver state.
    uint8_t                      state;       		///< PDM peripheral operation state.
    uint8_t                      active_buffer;     ///< Number of currently active buffer.
    uint8_t                      error;             ///< Driver error flag.
    uint8_t                      irq_priority;      ///< Interrupt priority.
    volatile uint8_t             irq_buff_request;  ///< Request the next buffer in the ISR.
    
    uint32_t trg_cnt;
    uint8_t skip_initial;
    uint8_t bflag;   
} PDM_INFO;

void initPDM(void);
void deinitPDM(void);
void startPDM(void);
void stopPDM(void);
void setBufferPDM(int16_t * buffer, uint16_t buffer_length);
void chkPDM(void);

void nrfx_pdm1_irq_handler(void * p_event, void * p_context);

extern struct k_poll_signal signal_eram_action;

extern PDM_INFO g_PDM_INFO;
#endif
