#ifndef __SPI_H__
#define __SPI_H__

#include <zephyr.h>
#include <zephyr/types.h>
#include <stddef.h>
#include <string.h>
#include <errno.h>
#include <sys/printk.h>
#include <sys/byteorder.h>
							

// #define SPI1_CS				    7	
// #define SPI1_SCK				8
// #define SPI1_MISO				23
// #define SPI1_MOSI			    24	

// #define SPI1_CS_HIGH			NRF_P0->OUTSET = (1<<(SPI1_CS));
// #define SPI1_CS_LOW				NRF_P0->OUTCLR = (1<<(SPI1_CS));

#define SPI1_CS                 15  
#define SPI1_SCK                12
#define SPI1_MISO               14
#define SPI1_MOSI               13  
#define SPI_DCX                 28
#define SPI1_CS_HIGH            NRF_P1->OUTSET = (1<<(SPI1_CS));
#define SPI1_CS_LOW             NRF_P1->OUTCLR = (1<<(SPI1_CS));

uint8_t initSPI1(void);
void deinitSPI1(void);
void txByteSSPI(uint8_t data);
uint8_t rxByteSSPI(void);
uint8_t txDataSPI1(uint8_t * tx_data, uint32_t tx_size);
uint8_t rxDataSPI1(uint8_t * rx_data, uint32_t rx_size);
void setCsSPI1(uint8_t state);
void delaySPI(void);

#endif 
